diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index d3df9372d..a4c6ddfc1 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -4,487 +4,407 @@ package net.minecraft.core.player.inventory.container;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.player.inventory.InventorySorter;
-import net.minecraft.core.util.helper.DamageType;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Arrays;
+import java.util.Objects;
+
 public class ContainerInventory
-    implements Container
-{
-    protected int hotbarOffset = 0;
-    public @Nullable ItemStack @NotNull [] mainInventory;
-    public @Nullable ItemStack @NotNull [] armorInventory;
-    protected int currentItem;
-    public @NotNull Player player;
-    private ItemStack heldItem;
-    public boolean inventoryChanged;
-
-    public ContainerInventory(@NotNull Player player)
-    {
-        mainInventory = new ItemStack[36];
-        armorInventory = new ItemStack[4];
-        currentItem = 0;
-        inventoryChanged = false;
+    implements Container {
+    public static final int MAIN_INVENTORY_SIZE = 36;
+    public static final int ARMOR_INVENTORY_SIZE = 4;
+    public static final int HOTBAR_SIZE = 9;
+
+    private static final int NBT_ARMOR_SLOT_OFFSET = 100;
+
+    public final @NotNull Player player;
+
+    public final @Nullable ItemStack @NotNull [] mainInventory = new ItemStack[MAIN_INVENTORY_SIZE];
+    public final @Nullable ItemStack @NotNull [] armorInventory = new ItemStack[ARMOR_INVENTORY_SIZE];
+
+    private int currentSlot = 0;
+    private @Nullable ItemStack heldItem = null;
+    private int hotbarOffset = 0;
+
+    public ContainerInventory(final @NotNull Player player) {
         this.player = player;
     }
 
+    @Override
+    public @Nullable ItemStack getItem(int slot) {
+        @Nullable ItemStack @NotNull [] inventory = this.mainInventory;
+
+        if (slot >= MAIN_INVENTORY_SIZE) {
+            inventory = this.armorInventory;
+            slot -= MAIN_INVENTORY_SIZE;
+        }
+
+        return inventory[slot];
+    }
+
+    @Override
+    public void setItem(int slot, final @Nullable ItemStack stack) {
+        @Nullable ItemStack @NotNull [] inventory = this.mainInventory;
+
+        if (slot >= MAIN_INVENTORY_SIZE) {
+            inventory = this.armorInventory;
+            slot -= MAIN_INVENTORY_SIZE;
+        }
+
+        inventory[slot] = stack;
+    }
+
     public int getHotbarOffset() {
-        return hotbarOffset;
+        return this.hotbarOffset;
     }
 
-    public void setHotbarOffset(int offset, boolean overrideLock) {
-        if (!overrideLock && currentItemLocked()) return;
-        hotbarOffset = offset;
+    public void setHotbarOffset(final int offset, final boolean overrideLock) {
+        if (!overrideLock && this.currentSlotLocked()) {
+            return;
+        }
+
+        this.hotbarOffset = offset;
     }
 
-    @Nullable
-    public ItemStack getCurrentItem()
-    {
-        if(currentItem < 9 + hotbarOffset && currentItem >= hotbarOffset)
-        {
-            return mainInventory[currentItem];
-        } else
-        {
+
+    public @Nullable ItemStack getCurrentItem() {
+        if (this.currentSlot >= this.hotbarOffset && this.currentSlot < this.hotbarOffset + HOTBAR_SIZE) {
+            return this.mainInventory[this.currentSlot];
+        } else {
             return null;
         }
     }
 
-    public int getCurrentItemIndex() {
-        return currentItem;
+    public int setCurrentItem(final @NotNull ItemStack stack) {
+        if (this.currentSlotLocked()) {
+            return this.currentSlot;
+        }
+
+        if (stack.itemID < Blocks.blocksList.length) {
+            if (Objects.requireNonNull(Blocks.blocksList[stack.itemID]).hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) {
+                return this.currentSlot;
+            }
+        } else {
+            if (Objects.requireNonNull(Item.itemsList[stack.itemID]).hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) {
+                return this.currentSlot;
+            }
+        }
+
+        for (int i = this.hotbarOffset; i < this.hotbarOffset + HOTBAR_SIZE; i++) {
+            final @Nullable ItemStack hotbarStack = this.mainInventory[i];
+            if (hotbarStack != null && hotbarStack.itemID == stack.itemID) {
+                this.currentSlot = i;
+                return this.currentSlot;
+            }
+        }
+
+        this.mainInventory[this.currentSlot] = stack;
+
+        return this.currentSlot;
     }
 
-    public void setCurrentItemIndex(int index, boolean overrideLock) {
-        if (!overrideLock && currentItemLocked()) return;
-        currentItem = index;
+    public int getCurrentSlot() {
+        return this.currentSlot;
     }
-    
-    public static int playerMainInventorySize()
-    {
-        return 9 * 4;
+
+    public void setCurrentSlot(final int slot, final boolean overrideLock) {
+        if (!overrideLock && this.currentSlotLocked()) return;
+        this.currentSlot = slot;
     }
 
-    private int getInventorySlotContainItem(int i)
-    {
-        for(int j = 0; j < mainInventory.length; j++)
-        {
-            if(mainInventory[j] != null && mainInventory[j].itemID == i)
-            {
-                return j;
-            }
+    public void setHeldItemStack(final @Nullable ItemStack itemstack) {
+        this.heldItem = itemstack;
+
+        if (itemstack != null && itemstack.stackSize <= 0) {
+            this.heldItem = null;
         }
+    }
 
-        return -1;
+    public @Nullable ItemStack getHeldItemStack() {
+        return this.heldItem;
     }
 
-    private int storeItemStack(ItemStack itemstack)
-    {
-        for(int i = 0; i < mainInventory.length; i++)
-        {
-            if (mainInventory[i] != null &&
-                    mainInventory[i].itemID == itemstack.itemID &&
-                    mainInventory[i].isStackable() &&
-                    mainInventory[i].stackSize < mainInventory[i].getMaxStackSize() &&
-                    mainInventory[i].stackSize < getMaxStackSize() &&
-                    (!mainInventory[i].getHasSubtypes() || mainInventory[i].getMetadata() == itemstack.getMetadata())
-            )
-            {
+    private int getFirstSlotContaining(final int itemId) {
+        for (int i = 0; i < this.mainInventory.length; i++) {
+            final @Nullable ItemStack stack = this.mainInventory[i];
+            if (stack != null && stack.itemID == itemId) {
                 return i;
             }
         }
 
         return -1;
     }
-	
+
     /**
      * Add an ItemStack into the players inventory. When items are added to the players inventory, the stack size of the given ItemStack is reduced. <br>
-     * The given ItemStack may have a stack size that is higher than its limit, which is the case when items are taken out of a basket. 
+     * The given ItemStack may have a stack size that is higher than its limit, which is the case when items are taken out of a basket.
      */
-    public void insertItem(ItemStack stackToAdd, boolean useHotbarOffset) {
-    	// In the first stage we combine the given item with stacks that are already in the inventory
-    	// In the second stage we put the remaining items into empty slots
-        if (!player.getGamemode().canInteract()) return;
-    	for(int stage = 0; stage < 2; stage++) {
-        	for(int i=0; i < mainInventory.length; i++) {
-        		int slotId = useHotbarOffset ? (i + hotbarOffset) % mainInventory.length : i;
-
-                if (locked(slotId)) continue;
-
-        		ItemStack stackInSlot = mainInventory[slotId];
-        		
-        		if(stage == 0) {
-        			if(stackInSlot != null && stackInSlot.canStackWith(stackToAdd)) {
-            			int transferAmount = Math.min(stackToAdd.stackSize, stackInSlot.getMaxStackSize() - stackInSlot.stackSize);
-            			transferAmount = Math.min(transferAmount, stackToAdd.getMaxStackSize()); // When taking items out of a basket item stacks may have stack sizes higher than their limit
-            			
-            			if(transferAmount == 0) {
-            				continue;
-            			}
-        				stackInSlot.stackSize += transferAmount;
-        				stackToAdd.stackSize -= transferAmount;
-        				stackInSlot.animationsToGo = 5;
-        			}
-        		}else if(stage == 1) {
-            		if(stackInSlot == null) {
-            			int transferAmount = Math.min(stackToAdd.stackSize, stackToAdd.getMaxStackSize());
-            			
-            			mainInventory[slotId] = stackToAdd.copy();
-            			mainInventory[slotId].stackSize = transferAmount;
-            			mainInventory[slotId].animationsToGo = 5;
-            			
-            			stackToAdd.stackSize -= transferAmount;
-            			
-            		}
-        		}
-        		
-    			if(stackToAdd.stackSize <= 0) {
-    				return;
-    			}
-        	}
-    	}
-    }
-
-    public int setCurrentItem(ItemStack itemstack, boolean flag)
-    {
-        if (currentItemLocked()) return currentItem;
-    	if (!flag) return currentItem;
-    	
-    	if (itemstack.itemID < Blocks.blocksList.length)
-    	{
-    		if (Blocks.blocksList[itemstack.itemID].hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) return currentItem;
-    	}
-    	else
-    	{
-    		if (Item.itemsList[itemstack.itemID].hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) return currentItem;
-    	}
-    	
-    	for (int j = hotbarOffset; j < 9 + hotbarOffset; j++)
-    	{
-    		if (mainInventory[j] != null && mainInventory[j].itemID == itemstack.itemID) 
-			{
-    			currentItem = j;
-    			return currentItem;
-			}
-    	}
-    	
-        mainInventory[currentItem] = itemstack;
-        
-        return currentItem;
-    }
-
-    public void changeCurrentItem(int i)
-    {
-        if (currentItemLocked()) return;
-        if(i > 0)
-        {
-            i = 1;
+    public void insertItem(final @NotNull ItemStack stackToAdd, final boolean useHotbarOffset) {
+        // In the first stage we combine the given item with stacks that are already in the inventory
+        // In the second stage we put the remaining items into empty slots
+        if (!this.player.getGamemode().canInteract()) return;
+        for (int stage = 0; stage < 2; stage++) {
+            for (int i = 0; i < this.mainInventory.length; i++) {
+                final int slotId = useHotbarOffset ? (i + this.hotbarOffset) % this.mainInventory.length : i;
+
+                if (this.locked(slotId)) continue;
+
+                final @Nullable ItemStack stackInSlot = this.mainInventory[slotId];
+
+                if (stage == 0) {
+                    if (stackInSlot != null && stackInSlot.canStackWith(stackToAdd)) {
+                        int transferAmount = Math.min(stackToAdd.stackSize, stackInSlot.getMaxStackSize() - stackInSlot.stackSize);
+                        transferAmount = Math.min(transferAmount, stackToAdd.getMaxStackSize()); // When taking items out of a basket item stacks may have stack sizes higher than their limit
+
+                        if (transferAmount == 0) {
+                            continue;
+                        }
+                        stackInSlot.stackSize += transferAmount;
+                        stackToAdd.stackSize -= transferAmount;
+                        stackInSlot.animationsToGo = 5;
+                    }
+                } else if (stage == 1) {
+                    if (stackInSlot == null) {
+                        final int transferAmount = Math.min(stackToAdd.stackSize, stackToAdd.getMaxStackSize());
+
+                        final @NotNull ItemStack stackCopy = stackToAdd.copy();
+                        stackCopy.stackSize = transferAmount;
+                        stackCopy.animationsToGo = 5;
+                        this.mainInventory[slotId] = stackCopy;
+
+                        stackToAdd.stackSize -= transferAmount;
+                    }
+                }
+
+                if (stackToAdd.stackSize <= 0) {
+                    return;
+                }
+            }
         }
-        if(i < 0)
-        {
-            i = -1;
+    }
+
+    public void changeCurrentSlot(int offset) {
+        if (this.currentSlotLocked()) {
+            return;
+        }
+
+        if (offset > 0) {
+            offset = 1;
+        }
+        if (offset < 0) {
+            offset = -1;
+        }
+        this.currentSlot -= offset;
+
+        while (this.currentSlot < this.hotbarOffset) {
+            this.currentSlot += HOTBAR_SIZE;
+        }
+        while (this.currentSlot >= this.hotbarOffset + HOTBAR_SIZE) {
+            this.currentSlot -= HOTBAR_SIZE;
         }
-        for(currentItem -= i; currentItem < hotbarOffset; currentItem += 9) { }
-        for(; currentItem >= 9 + hotbarOffset; currentItem -= 9) { }
     }
 
-    public void decrementAnimations()
-    {
-        for(int slot = 0; slot < mainInventory.length; slot++)
-        {
-            if(mainInventory[slot] != null)
-            {
-                mainInventory[slot].updateAnimation(player.world, player, slot, currentItem == slot);
+    public void decrementAnimations() {
+        for (int i = 0; i < this.mainInventory.length; i++) {
+            final @Nullable ItemStack stack = this.mainInventory[i];
+            if (stack != null) {
+                stack.updateAnimation(this.player.world, this.player, i, this.currentSlot == i);
             }
         }
 
     }
 
-    public boolean consumeInventoryItem(int i)
-    {
-        int j = getInventorySlotContainItem(i);
-        if(j < 0)
-        {
+    public boolean consumeInventoryItem(final int itemId) {
+        final int slot = this.getFirstSlotContaining(itemId);
+        if (slot < 0) {
             return false;
         }
 
-    	if (player.getGamemode().consumeBlocks())
-        {
-    		if(--mainInventory[j].stackSize <= 0)
-    		{
-    			mainInventory[j] = null;
-    		}
+        if (this.player.getGamemode().hasBlockConsumption()) {
+            final @NotNull ItemStack stack = Objects.requireNonNull(this.mainInventory[slot]);
+
+            stack.stackSize--;
+            if (stack.stackSize <= 0) {
+                this.mainInventory[slot] = null;
+            }
         }
+
         return true;
     }
 
-    public boolean currentItemLocked() {
-        return player.getHeldObject() != null;
+    public boolean currentSlotLocked() {
+        return this.player.getHeldObject() != null;
     }
 
     @Override
-    public boolean locked(int index) {
-        return currentItemLocked() && index == currentItem;
+    public boolean locked(final int slot) {
+        return this.currentSlotLocked() && slot == this.currentSlot;
     }
 
     @Override
-	public @Nullable ItemStack removeItem(int index, int takeAmount)
-    {
-        ItemStack aitemstack[] = mainInventory;
-        if(index >= mainInventory.length)
-        {
-            aitemstack = armorInventory;
-            index -= mainInventory.length;
+    public @Nullable ItemStack removeItem(int slot, final int takeAmount) {
+        @Nullable ItemStack @NotNull [] inventory = this.mainInventory;
+
+        if (slot >= MAIN_INVENTORY_SIZE) {
+            inventory = this.armorInventory;
+            slot -= MAIN_INVENTORY_SIZE;
         }
-        if(aitemstack[index] != null)
-        {
-            if(aitemstack[index].stackSize <= takeAmount)
-            {
-                ItemStack itemstack = aitemstack[index];
-                aitemstack[index] = null;
-                return itemstack;
+
+        final @Nullable ItemStack currentStack = inventory[slot];
+        if (currentStack != null) {
+            if (currentStack.stackSize <= takeAmount) {
+                inventory[slot] = null;
+                return currentStack;
             }
-            ItemStack itemstack1 = aitemstack[index].splitStack(takeAmount);
-            if(aitemstack[index].stackSize <= 0)
-            {
-                aitemstack[index] = null;
+            final @NotNull ItemStack otherHalf = currentStack.splitStack(takeAmount);
+            if (currentStack.stackSize <= 0) {
+                inventory[slot] = null;
             }
-            return itemstack1;
-        } else
-        {
+
+            return otherHalf;
+        } else {
             return null;
         }
     }
 
-    @Override
-	public void setItem(int index, @Nullable ItemStack itemstack)
-    {
-        ItemStack aitemstack[] = mainInventory;
-        if(index >= aitemstack.length)
-        {
-            index -= aitemstack.length;
-            aitemstack = armorInventory;
-        }
-        aitemstack[index] = itemstack;
-    }
+    public @NotNull ListTag save(final @NotNull ListTag parentTag) {
+        for (int i = 0; i < this.mainInventory.length; i++) {
+            final @Nullable ItemStack stack = this.mainInventory[i];
 
-    public float getStrVsBlock(@NotNull Block<?> block)
-    {
-        float f = 1.0F;
-        if(mainInventory[currentItem] != null)
-        {
-            f *= mainInventory[currentItem].getStrVsBlock(block);
-        }
-        return f;
-    }
-
-    public ListTag writeToNBT(ListTag nbttaglist)
-    {
-        for(int i = 0; i < mainInventory.length; i++)
-        {
-            if(mainInventory[i] != null)
-            {
-                CompoundTag nbttagcompound = new CompoundTag();
-                nbttagcompound.putByte("Slot", (byte)i);
-                mainInventory[i].writeToNBT(nbttagcompound);
-                nbttaglist.addTag(nbttagcompound);
+            if (stack != null) {
+                final @NotNull CompoundTag itemTag = new CompoundTag();
+
+                itemTag.putByte("Slot", (byte) i);
+                stack.writeToNBT(itemTag);
+                parentTag.addTag(itemTag);
             }
         }
 
-        for(int j = 0; j < armorInventory.length; j++)
-        {
-            if(armorInventory[j] != null)
-            {
-                CompoundTag nbttagcompound1 = new CompoundTag();
-                nbttagcompound1.putByte("Slot", (byte)(j + 100));
-                armorInventory[j].writeToNBT(nbttagcompound1);
-                nbttaglist.addTag(nbttagcompound1);
+        for (int i = 0; i < this.armorInventory.length; i++) {
+            final @Nullable ItemStack stack = this.armorInventory[i];
+
+            if (stack != null) {
+                final @NotNull CompoundTag itemTag = new CompoundTag();
+
+                itemTag.putByte("Slot", (byte) (i + NBT_ARMOR_SLOT_OFFSET));
+                stack.writeToNBT(itemTag);
+                parentTag.addTag(itemTag);
             }
         }
 
-        return nbttaglist;
+        return parentTag;
     }
 
-    public void readFromNBT(ListTag nbttaglist)
-    {
-        mainInventory = new ItemStack[36];
-        armorInventory = new ItemStack[4];
-        for(int i = 0; i < nbttaglist.tagCount(); i++)
-        {
-            CompoundTag nbttagcompound = (CompoundTag)nbttaglist.tagAt(i);
-            int j = nbttagcompound.getByte("Slot") & 0xff;
-            ItemStack itemstack = ItemStack.readItemStackFromNbt(nbttagcompound);
-            if(itemstack  == null)
-            {
+    public void load(final @NotNull ListTag parentTag) {
+        this.clear();
+
+        for (int i = 0; i < parentTag.tagCount(); i++) {
+            final @NotNull CompoundTag itemTag = (CompoundTag) parentTag.tagAt(i);
+            final int slot = itemTag.getByte("Slot") & 0xFF;
+            final @Nullable ItemStack stack = ItemStack.readItemStackFromNbt(itemTag);
+
+            if (stack == null) {
                 continue;
             }
-            if(j >= 0 && j < mainInventory.length)
-            {
-                mainInventory[j] = itemstack;
+            if (slot < MAIN_INVENTORY_SIZE) {
+                this.mainInventory[slot] = stack;
             }
-            if(j >= 100 && j < armorInventory.length + 100)
-            {
-                armorInventory[j - 100] = itemstack;
+            if (slot >= NBT_ARMOR_SLOT_OFFSET && slot < ARMOR_INVENTORY_SIZE + NBT_ARMOR_SLOT_OFFSET) {
+                this.armorInventory[slot - NBT_ARMOR_SLOT_OFFSET] = stack;
             }
         }
-
     }
 
-    @Override
-	public int getContainerSize()
-    {
-        return mainInventory.length + 4;
+    private void clear() {
+        Arrays.fill(this.mainInventory, null);
+        Arrays.fill(this.armorInventory, null);
     }
 
     @Override
-	public @Nullable ItemStack getItem(int index)
-    {
-        ItemStack aitemstack[] = mainInventory;
-        if(index >= aitemstack.length)
-        {
-            index -= aitemstack.length;
-            aitemstack = armorInventory;
-        }
-        return aitemstack[index];
+    public int getContainerSize() {
+        return this.mainInventory.length + 4;
     }
 
     @Override
-	public String getNameTranslationKey()
-    {
+    public @NotNull String getNameTranslationKey() {
         return "container.inventory.name";
     }
 
     @Override
-	public int getMaxStackSize()
-    {
+    public int getMaxStackSize() {
         return 64;
     }
 
-    public int getDamageVsEntity(@NotNull Entity entity)
-    {
-        ItemStack itemstack = getItem(currentItem);
-        if(itemstack != null)
-        {
-            return itemstack.getDamageVsEntity(entity);
-        } else
-        {
-            return 1;
-        }
+    public @Nullable ItemStack armorItemInSlot(final @NotNull IArmorShape shape) {
+        return this.armorInventory[shape.getSlotIndex()];
     }
 
-    public boolean canHarvestBlock(Block<?> block)
-    {
-        if (block == null) return false;
-        if(block.getMaterial().isAlwaysDestroyable())
-        {
-            return true;
-        }
-        ItemStack itemstack = getItem(currentItem);
-        if(itemstack != null)
-        {
-            return itemstack.canHarvestBlock(player, block);
-        } else
-        {
-            return false;
+    public int getTotalArmorPoints() {
+        float armorDurability = 0.0f;
+        float maxDurability = 0.0f;
+
+        for (final @Nullable ItemStack stack : this.armorInventory) {
+            if (stack != null && stack.getItem() instanceof IArmorItem) {
+                final Item armor = stack.getItem();
+
+                maxDurability += armor.getMaxDamage();
+                armorDurability += armor.getMaxDamage() - stack.getMetadata();
+            }
         }
+
+        return (int) (20 * (armorDurability / maxDurability));
     }
 
-    public @Nullable ItemStack armorItemInSlot(@NotNull IArmorShape shape)
-    {
-        return armorInventory[shape.getSlotIndex()];
-    }
-
-    public int getTotalArmourPoints() {
-    	float armorDurability = 0.0f;
-    	float maxDurability = 0.0f;
-    	
-    	for(int armorPiece=0; armorPiece < armorInventory.length; armorPiece++) {
-    		ItemStack itemStack = armorInventory[armorPiece];
-    		if(itemStack != null && itemStack.getItem() instanceof IArmorItem) {
-                Item armor = itemStack.getItem();
-    			
-    			maxDurability += armor.getMaxDamage();
-    			armorDurability += armor.getMaxDamage() - itemStack.getMetadata();
-    		}
-    	}
-    	
-    	return (int) (20 * (armorDurability / maxDurability));
-    }
-
-    public void dropAllItems()
-    {
-        for(int i = 0; i < mainInventory.length; i++)
-        {
-            if(mainInventory[i] != null)
-            {
-                player.dropPlayerItemWithRandomChoice(mainInventory[i], true);
-                mainInventory[i] = null;
+    public void dropAllItems() {
+        for (int i = 0; i < this.mainInventory.length; i++) {
+            final @Nullable ItemStack stack = this.mainInventory[i];
+            if (stack != null) {
+                this.player.dropItem(stack, true);
+                this.mainInventory[i] = null;
             }
         }
 
-        for(int j = 0; j < armorInventory.length; j++)
-        {
-            if(armorInventory[j] != null)
-            {
-                player.dropPlayerItemWithRandomChoice(armorInventory[j], true);
-                armorInventory[j] = null;
+        for (int i = 0; i < ARMOR_INVENTORY_SIZE; i++) {
+            if (this.armorInventory[i] != null) {
+                this.player.dropItem(this.armorInventory[i], true);
+                this.armorInventory[i] = null;
             }
         }
-
     }
 
     @Override
-	public void setChanged()
-    {
-        inventoryChanged = true;
-    }
-
-    public void setHeldItemStack(ItemStack itemstack)
-    {
-        heldItem = itemstack;
-        if (itemstack != null && itemstack.stackSize <= 0) heldItem = null;
-        player.onItemStackChanged(itemstack);
-    }
-
-    public ItemStack getHeldItemStack()
-    {
-        return heldItem;
+    public void setChanged() {
+        // Do nothing
     }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
-        if(player.removed)
-        {
+    public boolean stillValid(final @NotNull Player player) {
+        if (this.player.removed) {
             return false;
         }
-        return entityplayer.distanceToSqr(player) <= 64D;
+
+        return player.distanceToSqr(this.player) <= 64D;
     }
 
-    public boolean func_28018_c(ItemStack itemstack)
-    {
-        for(int i = 0; i < armorInventory.length; i++)
-        {
-            if(armorInventory[i] != null && armorInventory[i].isStackEqual(itemstack))
-            {
+    public boolean containsItem(final @NotNull ItemStack stack) {
+        for (final @Nullable ItemStack inventoryStack : this.armorInventory) {
+            if (inventoryStack != null && inventoryStack.isStackEqual(stack)) {
                 return true;
             }
         }
 
-        for(int j = 0; j < mainInventory.length; j++)
-        {
-            if(mainInventory[j] != null && mainInventory[j].isStackEqual(itemstack))
-            {
+        for (final @Nullable ItemStack inventoryStack : this.mainInventory) {
+            if (inventoryStack != null && inventoryStack.isStackEqual(stack)) {
                 return true;
             }
         }
@@ -493,19 +413,19 @@ public class ContainerInventory
     }
 
     @Override
-    public void sortContainer() {
-        InventorySorter.sortInventory(mainInventory, 9, mainInventory.length - 1);
-    }
-	
-	public void transferAllContents(ContainerInventory inventory) {
-		for(int i=0; i < mainInventory.length; i++) {
-			this.mainInventory[i] = inventory.mainInventory[i];
-			inventory.mainInventory[i] = null;
-		}
-		
-		for(int i=0; i < armorInventory.length; i++) {
-			this.armorInventory[i] = inventory.armorInventory[i];
-			inventory.armorInventory[i] = null;
-		}
-	}
+    public void sort() {
+        InventorySorter.sortInventory(this.mainInventory, HOTBAR_SIZE, MAIN_INVENTORY_SIZE - 1);
+    }
+
+    public void transferAllContents(final @NotNull ContainerInventory inventory) {
+        for (int i = 0; i < this.mainInventory.length; i++) {
+            this.mainInventory[i] = inventory.mainInventory[i];
+            inventory.mainInventory[i] = null;
+        }
+
+        for (int i = 0; i < this.armorInventory.length; i++) {
+            this.armorInventory[i] = inventory.armorInventory[i];
+            inventory.armorInventory[i] = null;
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
index 8146062fd..296abceee 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
@@ -2,76 +2,70 @@ package net.minecraft.core.player.inventory.container;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ContainerResult
-    implements Container
-{
-    private ItemStack[] items;
+    implements Container {
+    private @Nullable ItemStack stack = null;
 
-    public ContainerResult()
-    {
-        items = new ItemStack[1];
-    }
+    public ContainerResult() { }
 
     @Override
-	public int getContainerSize()
-    {
+    public int getContainerSize() {
         return 1;
     }
 
     @Override
-	public @Nullable ItemStack getItem(int index)
-    {
-        return items[index];
+    public @Nullable ItemStack getItem(final int slot) {
+        if (slot == 0) {
+            return this.stack;
+        }
+
+        return null;
     }
 
     @Override
-	public String getNameTranslationKey()
-    {
+    public @NotNull String getNameTranslationKey() {
         return "container.result.name";
     }
 
     @Override
-	public @Nullable ItemStack removeItem(int index, int takeAmount)
-    {
-        if(items[index] != null)
-        {
-            ItemStack itemstack = items[index];
-            items[index] = null;
-            return itemstack;
-        } else
-        {
+    public @Nullable ItemStack removeItem(final int slot, final int takeAmount) {
+        if (this.stack != null) {
+            final @NotNull ItemStack currentStack = this.stack;
+            this.stack = null;
+            return currentStack;
+        } else {
             return null;
         }
     }
 
     @Override
-	public void setItem(int index, @Nullable ItemStack itemstack)
-    {
-        items[index] = itemstack;
+    public void setItem(final int slot, final @Nullable ItemStack stack) {
+        if (slot == 0) {
+            this.stack = stack;
+        }
     }
 
 
     @Override
-	public int getMaxStackSize()
-    {
+    public int getMaxStackSize() {
         return 64;
     }
 
     @Override
-	public void setChanged()
-    {
+    public void setChanged() {
+        // Do nothing
     }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
+    public boolean stillValid(final @NotNull Player player) {
         return true;
     }
 
     @Override
-    public void sortContainer() {
+    public void sort() {
         // Do nothing
     }
 }
